const {
  timeConvert
} = require("../../utils/common")

// components/order-item/order-item.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    itemData: {
      value: null,
      type: Object
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    timeStr: '',
    leftTime: null
  },

  /**
   * 组件的方法列表
   */
  methods: {
    payAction(){
      this.triggerEvent("payAction",{orderId: this.data.itemData.id})
    },
    cancelAction(){
      this.triggerEvent("cancelAction",{orderId: this.data.itemData.id})
    },
    serviceAction(){
      this.triggerEvent("serviceAction")
    },
    finishAction(){
      this.triggerEvent("finishAction",{orderId: this.data.itemData.id})
    }
  },
  lifetimes: {
    attached() {
      if (this.data.itemData.leftTime) {
        let timeStr = timeConvert(this.data.itemData.leftTime)
        this.setData({
          leftTime: this.data.itemData.leftTime,
          timeStr
        })
        let that = this
        this.timer = setInterval(function(){
          let leftTime = that.data.leftTime
          let timeStr = timeConvert(leftTime)
          leftTime -= 1
          if(leftTime < 0){
            leftTime = 0
          }
          that.setData({
            leftTime,
            timeStr
          })
        }, 1000)
      }
    },
  },
  detached(){
    clearInterval(this.timer)
  }
})