// pages/address/index.js
import {
  ApiAddressList, ApiDefAddr, ApiDeleteAddr
} from '../../http/api'
import {
  wxDelete,
  wxPost
} from '../../http/network'
import {
  jumpPage, showToast
} from '../../utils/common'

var canLoadMore = true
var page = 1
Page({

  /**
   * 页面的初始数据
   */
  data: {
    list: null
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.path = options.path
  },
  onShow(){
    this.getData(true)
  },
  addAddressAction: jumpPage(function (e) {
    wx.navigateTo({
      url: './add-address',
    })
  }, true),
  getData(refresh) {
    if (refresh) {
      page = 1
    }
    wxPost(ApiAddressList, {
      "page": page
    }).then(res => {
      var list = this.data.list
      if (refresh) {
        list = res.data.list
      } else {
        list = list.concat(res.data.list)
      }
      this.setData({
        list
      })
      canLoadMore = res.data.hasNextPage
    })
  },
  onPullDownRefresh(e) {
    this.getData(true)
  },
  onReachBottom(e) {
    if (canLoadMore) {
      this.getData(false)
    }
  },
  defaultAction(e){
    let id = e.currentTarget.dataset.id
    let that = this
    wxPost(ApiDefAddr + id).then(res=>{
      that.getData(true)
      showToast("设置成功")
    })
  },
  deleteAction(e){
    let id = e.currentTarget.dataset.id
    let that = this
    wx.showModal({
      title:"删除提示",
      content: "您是否要删除该地址？",
      complete:function(e){
        if(e.confirm){
          wxDelete(ApiDeleteAddr + id).then(res=>{
            showToast(res.msg)
            that.getData(true)
          })
        }
      }
    })
  },
  modifyAction(e){
    let id = e.currentTarget.dataset.id
    wx.navigateTo({
      url: './add-address?id=' + id,
    })
  },
  chooseAction(e){
    let index = e.currentTarget.dataset.index
    if(this.path){
      let data = this.data.list[index]
      const eventChannel = this.getOpenerEventChannel()
      eventChannel.emit("getBackData",data)
      wx.navigateBack()
    }
  }
})